//*****************************************
// AVR ATmega1284 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:eep_dat.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"pr_mega1284_8x8dot_clock.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"dot8x8.h"
#include	"uart.h"
#include	"eep_dat.h"

uint16_t	eep_bps_600 EEMEM = BPS_600;			// UOOaor̒l
uint16_t	eep_bps_uart1 EEMEM = BPS_9600;			// XUOOaor̒l
static	unsigned short	eep_bfs[10];

//*****************************************
//@ddoqnl BPS_600 ǂݍ
//*****************************************
unsigned short	read_eep_bps_600(void)
{
	unsigned short	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_word(&eep_bps_600);		// Ǐo
	if((800 <= eep_bfs[0])&&(eep_bfs[0] <= 900)){
		r = eep_bfs[0];
	}else{
		r = BPS_600;
	}

	return(r);
}

//*****************************************
//@ddoqnl BPS_UART1 ǂݍ
//*****************************************
unsigned short	read_eep_bps_uart1(void)
{
	unsigned short	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_word(&eep_bps_uart1);		// Ǐo
	if(((BPS_9600-2) <= eep_bfs[0])&&(eep_bfs[0] <= (BPS_9600+5))){
		r = eep_bfs[0];
	}else if(((BPS_4800-4) <= eep_bfs[0])&&(eep_bfs[0] <= (BPS_4800+10))){
		r = eep_bfs[0];
	}else if(((BPS_2400-8) <= eep_bfs[0])&&(eep_bfs[0] <= (BPS_2400+20))){
		r = eep_bfs[0];
	}else if(((BPS_1200-16) <= eep_bfs[0])&&(eep_bfs[0] <= (BPS_1200+40))){
		r = eep_bfs[0];
	}else{
		r = BPS_9600;
	}

	return(r);
}

//*****************************************
//@ddoqnl BPS_600 
//*****************************************
void	write_eep_bps_600(unsigned short us)
{
	eep_bfs[0] = us;
	eeprom_busy_wait();
	eeprom_write_word(&eep_bps_600, eep_bfs[0]);		// 
	eeprom_busy_wait();
}

//*****************************************
//@ddoqnl BPS_uart1 
//*****************************************
void	write_eep_bps_uart1(unsigned short us)
{
	eep_bfs[0] = us;
	eeprom_busy_wait();
	eeprom_write_word(&eep_bps_uart1, eep_bfs[0]);		// 
	eeprom_busy_wait();
}

