//*****************************************
// AVR ATmega1284 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:port_bit.h
//  wb_[t@C
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//*****************************************

// XCb`
#define	SW1_ON_BIT		(1 << PINA0)			// set switch
#define	SW2_ON_BIT		(1 << PINA1)			// select switch

// XCb`P̑ԁiWrbgj
#define			SW1_ON_NOW			0x0100		// XCb`PꂽB
#define			SW1_OFF_SHORT		0x0200		// XCb`PꂽBĂԂ͒Z
#define			SW1_OFF_LONG		0x0400		// XCb`PꂽBĂԂ͒
#define			SW1_ON_CONTINUE		0x0800		// XCb`PꑱĂBi莞ԊԊuł̒lxoj
#define			SW1_ON				0x1000		// XCb`PꑱĂBiĂ鎞͂̒loj
#define			SW1_MASK			0x1f00		// XCb`P̐M𒊏o

// XCb`Q̑ԁiWrbgj
#define			SW2_ON_NOW			0x01		// XCb`QꂽB
#define			SW2_OFF_SHORT		0x02		// XCb`QꂽBĂԂ͒Z
#define			SW2_OFF_LONG		0x04		// XCb`QꂽBĂԂ͒
#define			SW2_ON_CONTINUE		0x08		// XCb`QꑱĂBi莞ԊԊuł̒lxoj
#define			SW2_ON				0x10		// XCb`QꑱĂBiĂ鎞͂̒loj
#define			SW2_MASK			0x1f		// XCb`Q̐M𒊏o

#define			SW_MASK				0x1f1f		// XCb`̐M𒊏o

// kdc
//  red: LED1 LED(H=ON, L=OFF)
#define	led1_init()	DDRD |= (1 << DDD7)					// Port-D Bit7 : Output
#define	led1_on()	PORTD |=  (1 << PD7)				// LED ON
#define	led1_off()	PORTD &= ~(1 << PD7)				// LED OFF

//  yellow: LED2 LED(H=ON, L=OFF)
#define	led2_init()	DDRD |= (1 << DDD6)					// Port-D Bit6 : Output
#define	led2_on()	PORTD |=  (1 << PD6)				// LED ON
#define	led2_off()	PORTD &= ~(1 << PD6)				// LED OFF

//  blue: LED3 LED(H=ON, L=OFF)
#define	led3_init()	DDRD |= (1 << DDD5)					// Port-D Bit5 : Output
#define	led3_on()	PORTD |=  (1 << PD5)				// LED ON
#define	led3_off()	PORTD &= ~(1 << PD5)				// LED OFF


extern	void			get_sw(void);
extern	void			sw_init(void);
extern	unsigned short	get_action_sw(void);
extern	void			wait_key_off(void);
extern	void			wait_sw_off(void);
