//*****************************************
// AVR ATmega1284 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:set_rtc_5keta.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega1284_8x8dot_clock.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"rtc_ds3234.h"
#include	"display.h"
#include	"dot8x8.h"
#include	"infrared.h"
#include	"set_rtc.h"
#include	"set_rtc_5keta.h"


//*****************************************
// N킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_year_5keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ye;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;
	unsigned char	wday;
	unsigned char	req_disp;						// \v

	ye = gRTC_year;
	disp_dot8x8_moji(5,' ');						// 
	disp_dot8x8_tow(6,0x20);						// N ʂQ\
	disp_dot8x8_tow(8,ye);							// N ʂQ\
	req_disp = 1;									// \vnm

	tim_10ms_blink = 0;								// _
	while(1){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ĂȂ ł̎(select switch)
				blk_stat = 1;
				disp_dot8x8_tow(8,0xff);				// uN \
			}else{
				blk_stat = 0;
				disp_dot8x8_tow(8,ye);				// N \
			}
			req_disp = 1;							// \vnm
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				ye++;
				if(9 < (ye & 0x0f)){				// X𒴂
					ye &= 0xf0;
					ye += 0x10;
				}
				if(0x99 < ye){
					ye = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_dot8x8_tow(8,ye);				// N ʂQ\
				if(gRTC_year == ye){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_year = ye;
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					wday++;
					gRTC_wday = wday;				// qsb j̃f[^ (BCD 1--7)
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_month_5keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mo;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;
	unsigned char	wday;
	unsigned char	req_disp;						// \v

	mo = gRTC_mon;
	disp_dot8x8_tow(5,mo);							//  ʂQ\
	disp_dot8x8_moji(7, '-');						// ;
	disp_dot8x8_tow(8,gRTC_day);					// \
	req_disp = 1;									// \vnm

	tim_10ms_blink = 0;								// _
	while(1){
		if(req_disp == 1){							// \vnm̎
			disp_dot8x8_all();						// WW S\
			req_disp = 0;							// \vnee
		}
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_dot8x8_tow(5,0xff);				// uN \
			}else{
				blk_stat = 0;
				disp_dot8x8_tow(5,mo);				//  \
			}
			req_disp = 1;							// \vnm
		}

		if(us != 0){								// EANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				mo++;
				if(9 < (mo & 0x0f)){				// X𒴂
					mo &= 0xf0;
					mo += 0x10;
				}
				if(0x12 < mo){
					mo = 1;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_dot8x8_tow(5,mo);				//  ʂQ\
				if(gRTC_mon == mo){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_mon = mo;
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					wday++;
					gRTC_wday = wday;				// qsb j̃f[^ (BCD 1--7)
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_day_5keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	da;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uru=0;
	unsigned char	syo=0;
	unsigned char	ucinf;
	unsigned char	wday;
	unsigned char	req_disp;							// \v

	if(((((gRTC_year/16)*10)+(gRTC_year/16))/4) == 0){	// 邤N
		uru=1;
	}
	if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
		syo=1;
	}
	da = gRTC_day;
	disp_dot8x8_tow(5,gRTC_mon);					// \
	disp_dot8x8_moji(7, '-');						// ;
	disp_dot8x8_tow(8,da);							// \
	req_disp = 1;									// \vnm

	tim_10ms_blink = 0;								// _
	while(1){
		if(req_disp == 1){							// \vnm̎
			disp_dot8x8_all();						// WW S\
			req_disp = 0;							// \vnee
		}
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_dot8x8_tow(8,0xff);				// uN \
			}else{
				blk_stat = 0;
				disp_dot8x8_tow(8,da);				//  \
			}
			req_disp = 1;							// \vnm
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				da++;
				if(9 < (da & 0x0f)){				// X𒴂
					da &= 0xf0;
					da += 0x10;
				}
				if(syo == 1){						// ̌
					if(0x30 < da){
						da = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){					// Q 邤N
						if(0x29 < da){
							da = 1;
						}
					}else{							// Q N
						if(0x28 < da){
							da = 1;
						}
					}
				}else{								// ̌
					if(0x31 < da){
						da = 1;
					}
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_dot8x8_tow(8,da);				// \
				if(gRTC_day == da){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_day = da;
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					wday++;
					gRTC_wday = wday;				// qsb j̃f[^ (BCD 1--7)
					rtc_write();					// RTC 
				}
				break;								// I
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_hour_5keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;
	unsigned char	req_disp;						// \v

	ho = gRTC_hou;
	disp_dot8x8_tow(5,ho);							// \
	disp_dot8x8_moji(7, ':');						// ;
	disp_dot8x8_tow(8,gRTC_min);					// \
	req_disp = 1;									// \vnm

	tim_10ms_blink = 0;								// _
	while(1){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_dot8x8_tow(5,0xff);				// uN \
			}else{
				blk_stat = 0;
				disp_dot8x8_tow(5,ho);				// \
			}
			req_disp = 1;							// \vnm
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				ho++;
				if(9 < (ho & 0x0f)){				// X𒴂
					ho &= 0xf0;
					ho += 0x10;
				}
				if(0x23 < ho){
					ho = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_dot8x8_tow(5,ho);				// \
				if(gRTC_hou == ho){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_hou = ho;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_minute_5keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;
	unsigned char	req_disp;						// \v

	mi = gRTC_min;
	disp_dot8x8_tow(5,gRTC_hou);					// \
	disp_dot8x8_moji(7, ':');						// ;
	disp_dot8x8_tow(8,mi);							// \
	req_disp = 1;									// \vnm

	tim_10ms_blink = 0;								// _
	while(1){
		if(req_disp == 1){							// \vnm̎
			disp_dot8x8_all();						// WW S\
			req_disp = 0;							// \vnee
		}
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_dot8x8_tow(8,0xff);			// uN\
			}else{
				blk_stat = 0;
				disp_dot8x8_tow(8,mi);				// \
			}
			req_disp = 1;							// \vnm
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				mi++;
				if(9 < (mi & 0x0f)){				// X𒴂
					mi &= 0xf0;
					mi += 0x10;
				}
				if(0x59 < mi){
					mi = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_dot8x8_tow(8,mi);				// \
				if(gRTC_min == mi){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_min = mi;
					gRTC_sec = 0;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// Tv킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
unsigned char	proc_set_rtc_5keta(void)
{
	unsigned char	r;

	disp_dot8x8_number(4, 15);						// 20221010 
	r = proc_set_year_5keta();						// N킹
	if(r == 0){
		r = proc_set_month_5keta();					// 킹
		if(r == 0){
			r = proc_set_day_5keta();				// 킹
			if(r == 0){
				r = proc_set_hour_5keta();			// 킹
				if(r == 0){
					r = proc_set_minute_5keta();	// 킹
				}
			}
		}
	}
	return(r);
}

