//*****************************************
// AVR ATmega1284 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:uart0.c
//
//  M̂ݎgp
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega1284_8x8dot_clock.h"
#include	"timer.h"
#include	"eep_dat.h"
#include	"uart.h"
#include	"uart0.h"

// **********************************************************
// ************************** UART **************************
// **********************************************************

#define			NofRxdBuf				64					// Mf[^obt@̑傫iQ̊KɌj
#define			DATA_WARITE_POS_MASK	(NofRxdBuf - 1)
unsigned char	rxd0_data[NofRxdBuf];						// Mf[^obt@
unsigned char	write_rxd0_pos = 0;
unsigned char	read_rxd0_pos = 0;
unsigned short	gBPS0 = BPS_600;

//***************************
// UART0 Initial
//***************************
void	uart0_init(void)
{
	PRR0 &= ~(1 << PRUSART0);									// UART0 ғ
	delay_2us(100/2);											// POOr҂

	gBPS0 = read_eep_bps_600();									//@ddoqnl BPS_600 ǂݍ

	UBRR0  = gBPS0;												// aor

	UCSR0C = (V_PARITY_NON | V_DATA_8);							// peBAf[^

	UCSR0A = V_UCSR0A;
	UCSR0B = V_UCSR0B;

}
//***************************
// UART0 Close
//***************************
void	uart0_close(void)
{
	UCSR0B = 0x00;
	PRR0 |= (1 << PRUSART0);										// ~
	delay_2us(100/2);											// POOr҂
}

//***************************
// UART0 TxD One Char
//  荞݂gȂ
//***************************
void	uart0_tx_one(unsigned char uc)
{
	while((UCSR0A & (1 << UDRE0)) == 0){
		;
	}
	UDR0 = uc;
}
//***************************
// UART0 TxD String
//  荞݂gȂ
//***************************
void	uart0_tx_str(char *str)
{
	while(*str != 0){
		uart0_tx_one((unsigned char)(*str));
		str++;
	}
}
//***************************
// UART0 TxD String + CR + LF
//***************************
void	uart0_tx_str_crlf(char *str)
{
	uart0_tx_str(str);											// UART TxD String
	uart0_tx_one(0x0d);											// CR
	uart0_tx_one(0x0a);											// LF
}

//***************************
// UART0 RXD0 Interrupt
//***************************
ISR	(USART0_RX_vect)
{
	unsigned char	er;
	unsigned char	uc;
	unsigned char	wr_pos;

	er = (UCSR0A & ((1<<FE0)|(1<<DOR0)|(1<<UPE0)) );	// G[Ԏ擾
	uc = UDR0;											// Mf[^擾

	if(er == 0){										// G[
		wr_pos = write_rxd0_pos;
		rxd0_data[wr_pos] = uc;							// Mf[^obt@Ɏ擾
		wr_pos++;
		wr_pos &= DATA_WARITE_POS_MASK;
		if(wr_pos != read_rxd0_pos){					// ݈ʒuǂݏoʒuɒǂĂȂ
			write_rxd0_pos = wr_pos;
		}
	}

}
//***************************
// RXD0 Read Call from Main
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
unsigned char	Get_rxd0(unsigned char *uc)
{
	unsigned char	r=0;
	if(write_rxd0_pos == read_rxd0_pos){						// Mf[^
		;
	}else{
		r = 1;
		*uc = rxd0_data[read_rxd0_pos];						// Mf[^obt@擾
		read_rxd0_pos++;
		read_rxd0_pos &= DATA_WARITE_POS_MASK;
	}
	return(r);
}

