//*****************************************
// AVR ATmega1284 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:uart1.c
//
//  M̂ݎgp
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega1284_8x8dot_clock.h"
#include	"timer.h"
#include	"eep_dat.h"
#include	"uart.h"
#include	"uart1.h"

// **********************************************************
// ************************** UART **************************
// **********************************************************

#define			NofRxdBuf				64					// Mf[^obt@̑傫iQ̊KɌj
#define			DATA_WARITE_POS_MASK	(NofRxdBuf - 1)
unsigned char	rxd1_data[NofRxdBuf];						// Mf[^obt@
unsigned char	write_rxd1_pos = 0;
unsigned char	read_rxd1_pos = 0;
unsigned short	gBPS1 = BPS_9600;

//***************************
// UART1 Initial
//***************************
void	uart1_init(void)
{
	PRR0 &= ~(1 << PRUSART1);									// UART1 ғ
	delay_2us(100/2);											// POOr҂

	gBPS1 = read_eep_bps_uart1();								//@ddoqnl BPS_9600 ǂݍ

	UBRR1  = gBPS1;												// aor

	UCSR1C = (V_PARITY_NON | V_DATA_8);							// peBAf[^

	UCSR1A = V_UCSR1A;
	UCSR1B = V_UCSR1B;

}
//***************************
// UART1 Close
//***************************
void	uart1_close(void)
{
	UCSR1B = 0x00;
	PRR0 |= (1 << PRUSART1);									// ~
	delay_2us(100/2);											// POOr҂
}

//***************************
// UART1 change BPS
//***************************
void	uart1_change_bps(unsigned short us)
{
	UCSR1B = 0x00;
	UBRR1  = us;												// aor
	UCSR1B = V_UCSR1B;
	delay_2us(100/2);											// POOr҂
}

//***************************
// UART1 TxD One Char
//  荞݂gȂ
//***************************
void	uart1_tx_one(unsigned char uc)
{
	while((UCSR1A & (1 << UDRE1)) == 0){
		;
	}
	UDR1 = uc;
}
//***************************
// UART1 TxD String
//  荞݂gȂ
//***************************
void	uart1_tx_str(char *str)
{
	while(*str != 0){
		uart1_tx_one((unsigned char)(*str));
		str++;
	}
}
//***************************
// UART1 TxD String + CR + LF
//***************************
void	uart1_tx_str_crlf(char *str)
{
	uart1_tx_str(str);											// UART1 TxD String
	uart1_tx_one(0x0d);											// CR
	uart1_tx_one(0x0a);											// LF
}

//***************************
// UART1 RXD Interrupt
//***************************
ISR	(USART1_RX_vect)
{
	unsigned char	er;
	unsigned char	uc;
	unsigned char	wr_pos;

	er = (UCSR1A & ((1<<FE1)|(1<<DOR1)|(1<<UPE1)) );	// G[Ԏ擾
	uc = UDR1;											// Mf[^擾

	if(er == 0){										// G[
		wr_pos = write_rxd1_pos;
		rxd1_data[wr_pos] = uc;							// Mf[^obt@Ɏ擾
		wr_pos++;
		wr_pos &= DATA_WARITE_POS_MASK;
		if(wr_pos != read_rxd1_pos){						// ݈ʒuǂݏoʒuɒǂĂȂ
			write_rxd1_pos = wr_pos;
		}
	}

}
//***************************
// RXD1 Read Call from Main
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
unsigned char	Get_rxd1(unsigned char *uc)
{
	unsigned char	r=0;
	if(write_rxd1_pos == read_rxd1_pos){					// Mf[^
		;
	}else{
		r = 1;
		*uc = rxd1_data[read_rxd1_pos];						// Mf[^obt@擾
		read_rxd1_pos++;
		read_rxd1_pos &= DATA_WARITE_POS_MASK;
	}
	return(r);
}

